#include<stdio.h>
#include <stdlib.h>
#include<iostream>
#include<fstream>
#include<sstream>
#include<string>
#include<map>
#include "graph.h"
#include "token.h"

using namespace std;

Graph DAG_tree;
int main(int argc, char ** argv) { 
  //Takes in a .dag.out file from unfoldsim.f90, outputs a dot file that contains the max 
  //path highlighted
    map<string, double> Nodes;
  double Tcutoff=0.0;
  if (argc < 2) {
    cerr << "Usage: ./maxTraffic <INPUT.traffic> [traffic_cutoff=0.01 dagfile_url ]" << endl;
    cerr << "Converts a traffic file to a DOT file" << endl;
    cerr << "Optional cutoff prunes paths with low traffic" << endl;
    cerr << "maxTraffic.cpp v.  Mon May  3 17:52:12 EDT 2010 C.Bystroff" << endl;
    exit(1);
  }
  if (argc < 4) {
    Tcutoff = atof(argv[2]);
  }
  cout << "#CREATED_BY maxTraffic.cpp v. Thu Jul 29 17:37:33 EDT 2010 " << endl;
  cout << "#starting ... argv[1]=" <<  argv[1] << endl;

  ifstream INFILE(argv[1]);
  char* dagfile=argv[1];
  if (!INFILE) { cerr << "maxTraffix:: DAG file not found : " << dagfile << endl; exit(1) ; }
  dagfile=token(argv[1]);
  if (argc > 2) {
    dagfile=argv[3];
    cout << "#Filename (arg 3) for use in map file=" << dagfile << endl;
  } else {
    cout << "#After token(): argv 1=" << argv[1] << " dagfile=" << dagfile << endl;
  }
  string name;
  while ( !INFILE.eof() ) { 
    INFILE >> name;
    if (name == "TSTATE") { //now add the transition states
      string node;
      string from;
      string to1;
      string to2;
      string type;
      string discard;
      string discard2;
      double traffic;
      bool stop = false;
      // INFILE >> node >> from >> to1 >> to2 >> discard >> type >> discard2 >> traffic;
      INFILE >> node >> from >> to1 >> to2 >> discard >> type >> traffic;
      if (traffic > Tcutoff) { //pruning step 1
	  if ( node == "" ) //check if last line
	    break;
	  if (type == "p" || type == "b" || type == "h" ) { 
	    node = "t"+type+node;
	    from = "n"+from;
	    to1 = "n"+to1;
	    to2 = "n"+to2;
	    DAG_tree.addNode(node, traffic);
	    DAG_tree.addNode(from, 0); //itermediate
	    DAG_tree.addNode(to1, 0); //intermediate
	    DAG_tree.addNode(to2, 0); //intermediate
	    DAG_tree.addEdge(from, node); //from to tstate
	    DAG_tree.addEdge(node, to1); //from tstate to one child
	    DAG_tree.addEdge(node, to2); //from tstate to other child
	  }
	  //cout << "the captured line is: transition " << node;
	  //cout << " goes from "<< from << " to nodes " << to1;
	  //cout << " and " << to2 << " with " << "traffic value of: ";
	  //cout << traffic << endl;
	  //}
      }
    }
  }
  cout << "#starting maxTraffic algorithm..." << endl;
  DAG_tree.getNode("n1")->highlight = true;
  DAG_tree.getNode("n1")->max_highlight = true;
  DAG_tree.maxTraffic( DAG_tree.getNode("n1") );
  INFILE.close();
  cout << "#number of nodes in maxTraffic: " << DAG_tree.max_val << endl;
  cout << "#Traffic cutoff used: " << Tcutoff << endl;
  cout << "digraph FILENAME" << endl;
  cout << "{" << endl;
  cout << "size=\"15, 25\"";
  DAG_tree.print_tree(DAG_tree.getNode("n1"), dagfile );
  cout << "}" << endl;
  return 0;
}
